%% hallar soldaduras mediante covarianza 
% cargando la seal MFL con la que se decea trabajar
clear all;
clc;
 
load('senal12_f.mat'); % seal MFL despues del filtrado shirinkage
senal=senal_f12;
clear senal_f12;


%% encontrar los 14 metros de las referencias
load('referencias_odometro_mm.mat');
sec1=0;
sec2=0;
sec3=0;
sec4=0;
sec5=0;
sec6=0;
cont =1;
for i =1645000:2426000
    
    if (target(i,1)==1)
       
        sec1(1,cont)=senal(1,i);
        sec1(2,cont)=odometro(i,1);
        sec1(3,cont)=target(i,1);
        sec1(4,cont)=target_n(i,1);
        cont=cont+1;
    end
    
end

cont =1;
for i =2843000:3261000
        if (target(i,1)==1)
       
        sec2(1,cont)=senal(1,i);
        sec2(2,cont)=odometro(i,1);
        sec2(3,cont)=target(i,1);
        sec2(4,cont)=target_n(i,1);
        cont=cont+1;
    end
    
end

cont =1;
for i =4677000:5118000
        if (target(i,1)==1)
       
        sec3(1,cont)=senal(1,i);
        sec3(2,cont)=odometro(i,1);
        sec3(3,cont)=target(i,1);
        sec3(4,cont)=target_n(i,1);
        cont=cont+1;
    end
    
end


cont =1;
for i =6186000:6603000
        if (target(i,1)==1)
       
        sec4(1,cont)=senal(1,i);
        sec4(2,cont)=odometro(i,1);
        sec4(3,cont)=target(i,1);
        sec4(4,cont)=target_n(i,1);
        cont=cont+1;
    end
    
end

cont =1;
for i =7764000:8251000
        if (target(i,1)==1)
       
        sec5(1,cont)=senal(1,i);
        sec5(2,cont)=odometro(i,1);
        sec5(3,cont)=target(i,1);
        sec5(4,cont)=target_n(i,1);
        cont=cont+1;
    end
    
end


cont =1;
for i =9157000:9574000
        if (target(i,1)==1)
       
        sec6(1,cont)=senal(1,i);
        sec6(2,cont)=odometro(i,1);
        sec6(3,cont)=target(i,1);
        sec6(4,cont)=target_n(i,1);
        cont=cont+1;
    end
    
end

%% reducir las referencias de 14 metros a solo
% escojer con cual de las muestras representativas se quiere hacer 

mu_re=sec5(1,379:606);
% mu_re=sec3(1,384:611);
% mu_re=sec2(1,837:1064);
% mu_re=sec1(1,1:228);
% mu_re=sec1(1,1486:1713);

clear sec1 sec2 sec3 sec4 sec5 sec6;

%% sacando covarianza entre la seal MFL y la oscilacion representatiVA
% seleccionanda en el paso anterior
% NOTA: esto puede demorar unos minutos
ventana = length(mu_re);                                


for j=1:length(senal(1,:))-ventana % paso la mu_ra por toda la seal

        matriz_cov = cov(senal(1,j:j+ventana-1)',mu_re');  
        covarianza(1,j) = matriz_cov(2,1);
        
        
        distancia(1,j)= mean(odometro(j:j+ventana-1,1));
        target_cov (j,1) = mode(target(j:j+ventana-1,1));
        target_cov_n (j,1) = mode(target_n(j:j+ventana-1,1));        
        
end

%% hallan la media y la desviacion estandar de los 6 puntos maximos 
% de oscilaciones en el target de 14 metros
% NOTA: para esto se debe ver en la siguiente grafica los puntos max verdes

figure (1)
plot(distancia,covarianza,'r',distancia,target_cov_n'.*covarianza,'g');
hold on;grid on;xlabel('distancia (m)');legend('covarianza','Target');
title('covarianza');


media=70;
desv = 30;

% medias para las 5 muestras representativas posibles a escojer 
% (2 secciones arriba) para la seal MFL 1

% media=47;
% desv = 20.9643;
% 
% media=16.1;
% desv = 5.8;
% 
% media=78.8;
% desv = 30.4;
% 
% media=52;
% desv = 19;
% 
% media=60;
% desv = 20;


%% Toma las covarianzas que esten por encima de la media menos la desviacion 
% estandar de las muestras representativas

largo_mure=227;

covarianza_completa=covarianza;
covarianza=0;
for i=1:length(covarianza_completa)
    
    if (covarianza_completa(i)>=media-desv)% de esta forma se toman todos los target tambien
        covarianza(i)=1;
    else
        covarianza(i)=0;
    end
end


% deteccion de flancos de subida 
cont=1;
dist=0;
for i=1:length(covarianza)-1
    
    if (covarianza(i)==0 && covarianza(i+1)==1)
        
        dist(cont,1)=i;
        dist(cont,2)=distancia(i);
        cont=cont+1;
end
end

% busco las covarianzas que se encuentren entre 10 y 13 metros o entre 23 y
% 25 metros, ya que son estas las que podrian ser soldaduras

cont=1;
diferencia_dis=0;
dist_solda=0;
for i=1:length(dist)-1
    
    diferencia_dis(i)=dist(i+1,2)-dist(i,2);
    
  if ((diferencia_dis(i)>=10)&&(diferencia_dis(i)<=13)|| (diferencia_dis(i)>=23)&&(diferencia_dis(i)<=25) )    
 
      dist_solda(cont,1)=dist(i,1); % numero de la muestra
      dist_solda(cont,2)=dist(i,2); % distancia en metros
      dist_solda(cont,3)=diferencia_dis(i); % diferencia de distancia a otra
      cont=cont+1;
  end
end

clear covarianza covarianza_completa target_cov target_cov_n distancia ...
        
% se construye vector de soldaduras
for i =1:length(senal) 
      soldaduras(i) = NaN;  
end

band=0;
for i =1:length(senal)
    i= i+(largo_mure)*band -1;
    for j=1:length(dist_solda)
        
    if dist_solda(j)==i
       
        for k=0:largo_mure
           soldaduras(i+k) = 1;  
        end
        
        band=band+1;
        break;
    end
    
    end
end

save('soldaduras_2','odometro','target_n','soldaduras','senal');
%% visualizacion

subplot(3,1,1)
plot (odometro(1:length(odometro)/3),senal(1:length(senal)/3),'r')
hold on;grid on;xlabel('distancia (m)');
plot (odometro(1:length(odometro)/3),target_n(1:length(target_n)/3)'.*senal(1:length(senal)/3),'g')
plot (odometro(1:length(odometro)/3),soldaduras(1:length(soldaduras)/3).*senal(1:length(senal)/3),'b');legend('seal','Target','Soldaduras');
hold off;

subplot(3,1,2)
plot (odometro(length(odometro)/3:length(odometro)*2/3),senal(length(senal)/3:length(senal)*2/3),'r')
hold on;grid on;xlabel('distancia (m)');
plot (odometro(length(odometro)/3:length(odometro)*2/3),target_n(length(target_n)/3:length(target_n)*2/3)'.*senal(length(senal)/3:length(senal)*2/3),'g')
plot (odometro(length(odometro)/3:length(odometro)*2/3),soldaduras(length(soldaduras)/3:length(soldaduras)*2/3).*senal(length(senal)/3:length(senal)*2/3),'b');
hold off;

subplot(3,1,3)
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),senal(length(senal)*2/3:length(senal)*3/3),'r')
hold on;grid on;xlabel('distancia (m)');
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),target_n(length(target_n)*2/3:length(target_n)*3/3)'.*senal(length(senal)*2/3:length(senal)*3/3),'g')
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),soldaduras(length(soldaduras)*2/3:length(soldaduras)*3/3).*senal(length(senal)*2/3:length(senal)*3/3),'b');
hold off;

% save('soldaduras_1','odometro','target_n','soldaduras','senal');
%% varias 
clear all;
clc;
load ('soldaduras_2.mat')
soldaduras_2=soldaduras;
load ('soldaduras_3.mat')
soldaduras_3=soldaduras;
load ('soldaduras_4.mat')
soldaduras_4=soldaduras;
load ('soldaduras_5.mat')
soldaduras_5=soldaduras;
load ('soldaduras_6.mat')
soldaduras_6=soldaduras;
load ('soldaduras_7.mat')
soldaduras_7=soldaduras;
load ('soldaduras_8.mat')
soldaduras_8=soldaduras;

load ('soldaduras_1.mat')

subplot(3,1,1)
plot (odometro(1:length(odometro)/3),senal(1:length(senal)/3),'r')
hold on;grid on;xlabel('distancia (m)');
plot (odometro(1:length(odometro)/3),target_n(1:length(target_n)/3)'.*senal(1:length(senal)/3),'g')
plot (odometro(1:length(odometro)/3),soldaduras(1:length(soldaduras)/3).*senal(1:length(senal)/3),'b');legend('seal','Target','Soldaduras');
plot (odometro(1:length(odometro)/3),soldaduras_2(1:length(soldaduras_2)/3).*senal(1:length(senal)/3),'b');
plot (odometro(1:length(odometro)/3),soldaduras_3(1:length(soldaduras_3)/3).*senal(1:length(senal)/3),'b');
plot (odometro(1:length(odometro)/3),soldaduras_4(1:length(soldaduras_4)/3).*senal(1:length(senal)/3),'b');
plot (odometro(1:length(odometro)/3),soldaduras_5(1:length(soldaduras_5)/3).*senal(1:length(senal)/3),'b');
plot (odometro(1:length(odometro)/3),soldaduras_6(1:length(soldaduras_6)/3).*senal(1:length(senal)/3),'b');
plot (odometro(1:length(odometro)/3),soldaduras_7(1:length(soldaduras_7)/3).*senal(1:length(senal)/3),'b');
plot (odometro(1:length(odometro)/3),soldaduras_8(1:length(soldaduras_8)/3).*senal(1:length(senal)/3),'b');
hold off;

subplot(3,1,2)
plot (odometro(length(odometro)/3:length(odometro)*2/3),senal(length(senal)/3:length(senal)*2/3),'r')
hold on;grid on;xlabel('distancia (m)');
plot (odometro(length(odometro)/3:length(odometro)*2/3),target_n(length(target_n)/3:length(target_n)*2/3)'.*senal(length(senal)/3:length(senal)*2/3),'g')
plot (odometro(length(odometro)/3:length(odometro)*2/3),soldaduras(length(soldaduras)/3:length(soldaduras)*2/3).*senal(length(senal)/3:length(senal)*2/3),'b');
plot (odometro(length(odometro)/3:length(odometro)*2/3),soldaduras_2(length(soldaduras_2)/3:length(soldaduras_2)*2/3).*senal(length(senal)/3:length(senal)*2/3),'b');
plot (odometro(length(odometro)/3:length(odometro)*2/3),soldaduras_3(length(soldaduras_3)/3:length(soldaduras_2)*2/3).*senal(length(senal)/3:length(senal)*2/3),'b');
plot (odometro(length(odometro)/3:length(odometro)*2/3),soldaduras_4(length(soldaduras_4)/3:length(soldaduras_2)*2/3).*senal(length(senal)/3:length(senal)*2/3),'b');
plot (odometro(length(odometro)/3:length(odometro)*2/3),soldaduras_5(length(soldaduras_5)/3:length(soldaduras_2)*2/3).*senal(length(senal)/3:length(senal)*2/3),'b');
plot (odometro(length(odometro)/3:length(odometro)*2/3),soldaduras_6(length(soldaduras_6)/3:length(soldaduras_2)*2/3).*senal(length(senal)/3:length(senal)*2/3),'b');
plot (odometro(length(odometro)/3:length(odometro)*2/3),soldaduras_7(length(soldaduras_7)/3:length(soldaduras_2)*2/3).*senal(length(senal)/3:length(senal)*2/3),'b');
plot (odometro(length(odometro)/3:length(odometro)*2/3),soldaduras_8(length(soldaduras_8)/3:length(soldaduras_2)*2/3).*senal(length(senal)/3:length(senal)*2/3),'b');
hold off;

subplot(3,1,3)
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),senal(length(senal)*2/3:length(senal)*3/3),'r')
hold on;grid on;xlabel('distancia (m)');
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),target_n(length(target_n)*2/3:length(target_n)*3/3)'.*senal(length(senal)*2/3:length(senal)*3/3),'g')
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),soldaduras(length(soldaduras)*2/3:length(soldaduras)*3/3).*senal(length(senal)*2/3:length(senal)*3/3),'b');
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),soldaduras_2(length(soldaduras_2)*2/3:length(soldaduras_2)*3/3).*senal(length(senal)*2/3:length(senal)*3/3),'b');
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),soldaduras_3(length(soldaduras_3)*2/3:length(soldaduras_2)*3/3).*senal(length(senal)*2/3:length(senal)*3/3),'b');
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),soldaduras_4(length(soldaduras_4)*2/3:length(soldaduras_2)*3/3).*senal(length(senal)*2/3:length(senal)*3/3),'b');
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),soldaduras_5(length(soldaduras_5)*2/3:length(soldaduras_2)*3/3).*senal(length(senal)*2/3:length(senal)*3/3),'b');
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),soldaduras_6(length(soldaduras_6)*2/3:length(soldaduras_2)*3/3).*senal(length(senal)*2/3:length(senal)*3/3),'b');
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),soldaduras_7(length(soldaduras_7)*2/3:length(soldaduras_2)*3/3).*senal(length(senal)*2/3:length(senal)*3/3),'b');
plot (odometro(length(odometro)*2/3:length(odometro)*3/3),soldaduras_8(length(soldaduras_8)*2/3:length(soldaduras_2)*3/3).*senal(length(senal)*2/3:length(senal)*3/3),'b');
hold off;
