%% filtrado shrinkage
% cargar la base de datos
clear all;
clc;

load('elemental1.mat');% cargar la base de datos

clear senal9 senal10 senal11 senal12 senal13 senal14 senal15 senal16 senal17...
        senal18 senal19 senal2 senal3 senal4 senal5 senal6 senal7 senal8
    
Odo_Z = 1;
% cortar seales a 4.311.000

corte=1:4311000;
senal1(corte,:)=[ ];
odometro(corte,:)=[ ]; 

%% determinar la mejor wavelet por prueba de dhonor mse y mejor nivel por 
% prueba de la entropia de shanon

clc;
senal=senal1;

f_madres ={'haar';'db2';'db3';'db4';'db5';'db6';'db7';'db8';'db9';'db10'...
    ;'bior1.3';'bior1.5';'bior2.2';'bior2.4';'bior2.6';'bior2.8';'bior3.1'...
    ;'bior3.3';'bior3.5';'bior3.7';'bior3.9';'bior4.4';'bior5.5';'bior6.8'...
    ;'coif1';'coif2';'coif3';'coif4';'coif5';'sym2';'sym3';'sym4';'sym5'...
    ;'sym6';'sym7';'sym9'};


for i=1:length(f_madres)

Lev=fix(abs(wmaxlev(senal,f_madres{i,1})));% max nivel de desconpocicion
% Lev=6; opcion para fijar el nivel manualmente
madre_w=f_madres{i,1};



[C,L] = wavedec(senal,Lev,madre_w);% descompocicion
senal_rec=waverec(C,L,madre_w); % reconstruccion

error(i,1) =sqrt(sum((senal-senal_rec).^2)/length(senal)); % error medio cuadratico
error(i,2) =Lev; 
i

end

mejor_madre_w=min(error(:,1));% la mejor seal wavelet madre sera la que 
                              % obtenga el menor error medio cuadratico 

%% detecminar parametros Filtro Shrinkage
clc
% Threshold Calculation
senal = senal1(Odo_Z:length(odometro));

clear Etiquetas senal2 senal3 senal4 senal5 senal6 senal7 senal8;

THR = zeros(4,1);
TPTR = {'rigrsure'; 'heursure'; 'sqtwolog'; 'minimaxi'};

    THR(:,1) = [thselect(senal(:,1),TPTR{1}), thselect(senal(:,1),TPTR{2}),...
        thselect(senal(:,1),TPTR{3}),thselect(senal(:,1),TPTR{4})];


% Threshold Scaling

W_one = 1;

W_sln = zeros(1,4);
W_mln = zeros(1,4);

i = 1;
    
    s = senal(:,i);
    
    N = (2^nextpow2(length(s)) - length(s));
    
    s = wextend('1','sym',s,N,'r');
    niveles = Lev;
    w_madre = mejor_madre_w;
    [swa,swd] = swt(s,niveles,w_madre);
    
    W_sln(i) = mean(abs(swd(1,:)))/0.6745;
    
    W_mln(i,1) = mean(abs(swd(1,:)))/0.6745;
    W_mln(i,2) = mean(abs(swd(2,:)))/0.6745;
    W_mln(i,3) = mean(abs(swd(3,:)))/0.6745;
    W_mln(i,4) = mean(abs(swd(4,:)))/0.6745;
    W_mln(i,5) = mean(abs(swd(5,:)))/0.6745;
    W_mln(i,6) = mean(abs(swd(6,:)))/0.6745;
    W_mln(i,7) = mean(abs(swd(7,:)))/0.6745;
    W_mln(i,8) = mean(abs(swd(8,:)))/0.6745;
    W_mln(i,9) = mean(abs(swd(9,:)))/0.6745;
    W_mln(i,10) = mean(abs(swd(10,:)))/0.6745;


SORH = {'h', 's'};
tic;
i=1 %Recorren las senales
    s = senal(:,i);
    N = (2^nextpow2(length(s)) - length(s));
    s = wextend('1','sym',s,N,'r');
    [swa,swd] = swt(s,niveles,w_madre);%nivel/madre
    for j=1:2 %Recorren entre H y S
        for k=1:3 %Recorren los pesos
            for l=1:4 %Recorren los umbrales
                
                if k==1
                    thr = THR(l,i)*W_one*ones(niveles,1);
                end
                
                if k==2
                    thr = THR(l,i)*W_sln(i)*ones(niveles,1);
                end
                
                if k==3
                    thr = THR(l,i)*W_mln(i,:);
                end
                
                mzero = zeros(size(swd));
                dswd = mzero;
                
                for thl = 1:niveles
                    dswd(thl,:) = wthresh(swd(thl,:),SORH{j},thr(thl));
                end
                
                A = mzero;
                A(niveles,:) = iswt(swa,mzero,w_madre);
                
                D = mzero;
                for ii = 1:niveles
                    D(ii,:) = iswt(mzero,dswd(ii,:),w_madre);
                    
                end
                 
%                       NOTA: S_r depende del numero de niveles (Lev).
%                       ejemplo: para lev = 10;
%               S_r = (D(10,1:length(s) - N) + D(9,1:length(s) - N)+...
%                       D(8,1:length(s) - N)  + D(7,1:length(s) - N)+...
%                       D(6,1:length(s) - N)  + D(5,1:length(s) - N)+...
%                       D(4,1:length(s) - N)  + D(3,1:length(s) - N)+...
%                       D(2,1:length(s) - N)  + D(1,1:length(s) - N)+...
%                       A(10,1:length(s) - N))';
                   
                S_r = (D(10,1:length(s) - N) + D(9,1:length(s) - N)+...
                       D(8,1:length(s) - N)  + D(7,1:length(s) - N)+...
                       D(6,1:length(s) - N)  + D(5,1:length(s) - N)+...
                       D(4,1:length(s) - N)  + D(3,1:length(s) - N)+...
                       D(2,1:length(s) - N)  + D(1,1:length(s) - N)+...
                       A(10,1:length(s) - N))';
                
                
                Result{i,j,k,l} = mse(s(1:length(s) - N) - S_r);
                
                [i j k l]
                toc;
                %pause
            end
        end
    end
save('MSE_Shrinkage.mat','Result')
%%  revisar la mejor combinacion de parametros

% por defecto = 1
% H S
% One Sln Mln
% rigrsure heursure sqtwolog minimaxi

load('MSE_Shrinkage.mat')
Result = cell2mat(Result);
min_mse = ones(1,3)*inf;
ind_min_mse = cell(1,3);
i=1 %Recorren las senales    
    for j=1:2 %Recorren entre H y S
        for k=1:3 %Recorren los pesos One Sln Mln
            for l=1:4 %Recorren los umbrales rigrsure heursure sqtwolog minimaxi
                
                if min_mse(i,1)>=Result(i,j,k,l)
                    
                    min_mse(i,3) = min_mse(i,2);
                    min_mse(i,2) = min_mse(i,1);
                    min_mse(i,1) = Result(i,j,k,l); 
                    ind_min_mse{i,3} = ind_min_mse{i,2};
                    ind_min_mse{i,2} = ind_min_mse{i,1};
                    ind_min_mse{i,1} = [i j k l];
                    
                end
                               
            end
        end
    end    

%% Aplicacion del filtro por medio de ventaneo

% 2^nextpow2(1e6)
clc

senal = senal1(Odo_Z:length(odometro)); % seleccion de la seal a filtrar

i = 1; %Indice de la senal (Paralelo)

    niveles = Lev;                       % nivel de aplicacion
    w_madre = mejor_madre_w;

S = senal(:,i);
snr_w = zeros(2,length(1000:1000:2e6));
clear senal;
idx = 1;

w=2^nextpow2(1e6) % ancho de la ventana
    
    w_act = 1;
    w_ena = true;
    S_r = zeros(1,length(S));
    w_last = 0;
    
    tic;
    
    while(w_ena)
        
        s = S(w_act:w_act+w);
        
        THR = thselect(s,'heursure');  % rigrsure heursure sqtwolog minimaxi
        
        N = (2^nextpow2(length(s)) - length(s));
        
        if length(s)<=2^niveles
            N = 2^niveles - (length(s));
        end
        
        s = wextend('1','sym',s,N,'r');
        
        [swa,swd] = swt(s,niveles,w_madre);
        
        
        % One Sln Mln
        
%         % one
%         thr = THR*ones(niveles,1);

%         % Sln
%         W_sln = mean(abs(swd(1,:)))/0.6745;
%         thr = THR*W_sln*ones(niveles,1);

%         % Mln. Nota: para usar Mln se debe tener encuenta el nivel=lev.
%         W_mln(i,1) = mean(abs(swd(1,:)))/0.6745;
%         W_mln(i,2) = mean(abs(swd(2,:)))/0.6745;
%         W_mln(i,3) = mean(abs(swd(3,:)))/0.6745;
%         W_mln(i,4) = mean(abs(swd(4,:)))/0.6745;
%         W_mln(i,5) = mean(abs(swd(5,:)))/0.6745;
%         W_mln(i,6) = mean(abs(swd(6,:)))/0.6745;
%         W_mln(i,7) = mean(abs(swd(7,:)))/0.6745;
%         W_mln(i,8) = mean(abs(swd(8,:)))/0.6745;
%         W_mln(i,9) = mean(abs(swd(9,:)))/0.6745;
%         W_mln(i,10) = mean(abs(swd(10,:)))/0.6745;
%         thr = THR*W_mln(1,:)*ones(niveles,1);
        
        
        mzero = zeros(size(swd));
        dswd = mzero;
        
        for thl = 1:niveles
            dswd(thl,:) = wthresh(swd(thl,:),'s',thr(thl)); % H S
        end
        
        A = mzero;
        A(niveles,:) = iswt(swa,mzero,w_madre);
        
        D = mzero;
        for ii = 1:niveles
            D(ii,:) = iswt(mzero,dswd(ii,:),w_madre);
            
        end
        
%                       NOTA: S_r depende del numero de niveles (Lev).
%                       ejemplo: para lev = 10;
%               S_r = (D(10,1:length(s) - N) + D(9,1:length(s) - N)+...
%                       D(8,1:length(s) - N)  + D(7,1:length(s) - N)+...
%                       D(6,1:length(s) - N)  + D(5,1:length(s) - N)+...
%                       D(4,1:length(s) - N)  + D(3,1:length(s) - N)+...
%                       D(2,1:length(s) - N)  + D(1,1:length(s) - N)+...
%                       A(10,1:length(s) - N))';
                   
                S_r = (D(10,1:length(s) - N) + D(9,1:length(s) - N)+...
                       D(8,1:length(s) - N)  + D(7,1:length(s) - N)+...
                       D(6,1:length(s) - N)  + D(5,1:length(s) - N)+...
                       D(4,1:length(s) - N)  + D(3,1:length(s) - N)+...
                       D(2,1:length(s) - N)  + D(1,1:length(s) - N)+...
                       A(10,1:length(s) - N))';
                
        
        if (w_act ==1)
            S_r(w_act:w_act+w) = s_r;
        else
            S_r(w_act) = (S_r(w_act) + s_r(1))/2;
            S_r(w_act+1:w_act+w) = s_r(2:end);
        end
        
        w_act = w_act+w-1;
        
        if w_last == 1
            w_ena = false;            
        end
        
        if (w_act+w) > length(S)
            w_last = w_last + 1;
            if w_last == 1                
                W = w;
            end
            w = length(S) - w_act;
        end
        
    end
    
    %Calculo SNR
    snr_w(i,idx) = 10*log10(sum(S'.^2)/(length(S)* mse(S'-S_r)));
    snr_w(2,idx) = W;
    idx = idx+1;
    senal_f1=S_r;
    save('senal1_f.mat','senal_f1','senal1')
    W
    toc;

clear A D dswd i idx ii mzero N niveles s s_r swa thl thr THR w W w_act ...
        w_ena w_last W_slnS_r;

    
   
ha (1)=subplot (2,1,1)
plot(odometro, senal1,'r')
hold on;grid on;xlabel('distancia (m)');
legend('Seal sin filtro');
ha (2)=subplot (2,1,2)
plot(odometro, senal_f1,'b')
hold on;grid on;xlabel('distancia (m)');
legend('Seal con filtro');
linkaxes(ha, 'xy');
axis tight;


    
